# Class CIM_TokenBucketMeterService
extends CIM_MeterService

This is a concrete subclass of the MeterService class that represents the metering of network traffic using a token bucket meter. Two types of token bucket meters are defined using this class - a simple, two-parameter bucket meter, and a multi-stage meter. A simple token bucket usually has two parameters, an average token rate and a burst size, and has two conformance levels: 'conforming' and 'non-conforming'. This class also defines an excess burst size, which enables the meter to have three conformance levels ('conforming', 'partially conforming', and 'non-conforming'). In this case, packets that exceed the excess burst size are deemed non-conforming, while packets that exceed the smaller burst size but are less than the excess burst size are deemed partially conforming.

### Table of Contents
Hierarchy
Direct Known Subclasses
Class Qualifiers
Class Properties
Class Methods

## Class Hierarchy

CIM_ManagedElement
|
+--CIM_ManagedSystemElement
|
+--CIM_LogicalElement
|
+--CIM_EnabledLogicalElement
|
+--CIM_Service
|
+--CIM_ConditioningService
|
+--CIM_MeterService
|
+--CIM_TokenBucketMeterService

## Direct Known Subclasses

## Class Qualifiers

Name | Data Type | Value
--- | --- | ---

Description

string

This is a concrete subclass of the MeterService class that represents the metering of network traffic using a token bucket meter. Two types of token bucket meters are defined using this class - a simple, two-parameter bucket meter, and a multi-stage meter. A simple token bucket usually has two parameters, an average token rate and a burst size, and has two conformance levels: 'conforming' and 'non-conforming'. This class also defines an excess burst size, which enables the meter to have three conformance levels ('conforming', 'partially conforming', and 'non-conforming'). In this case, packets that exceed the excess burst size are deemed non-conforming, while packets that exceed the smaller burst size but are less than the excess burst size are deemed partially conforming.

UMLPackagePath | string | CIM::Network::QoS
Version | string | 2.7.0

## Class Properties

### Local Class Properties

Name | Data Type | Default Value | Qualifiers
--- | --- | --- | ---
Name | Data Type | Value
AverageRate | uint32 |
Description | string | This property is a 32-bit unsigned integer that is used to define the committed rate of the meter. The value is expressed in kilobits per second.
Units | string | KiloBits per Second
BurstSize | uint32 |
Description | string | This property is a 32-bit unsigned integer that is used to define the maximum number of tokens available for the committed rate (specified by the AverageRate property). The value is specified in kilobytes.
Units | string | KiloBytes
ExcessBurstSize | uint32 |
Description | string | This property is a 32-bit unsigned integer that is used to define the maximum number of tokens available for the peak rate (specified by the PeakRate property). The value is specified in kilobytes.
Units | string | KiloBytes
PeakRate | uint32 |
Description | string | This attribute is a 32-bit unsigned integer that is used to define the peak rate of the meter. The value is expressed in kilobits per second.
Units | string | KiloBits per Second

### Inherited Properties

Name | Data Type | Class Origin
--- | --- | ---
Caption | string | CIM_ManagedElement
CommunicationStatus | uint16 | CIM_ManagedSystemElement
ConformanceLevels | uint16 | CIM_MeterService
CreationClassName | string | CIM_Service
Description | string | CIM_ManagedElement
DetailedStatus | uint16 | CIM_ManagedSystemElement
ElementName | string | CIM_ManagedElement
Enabled | boolean | CIM_ConditioningService
EnabledDefault | uint16 | CIM_EnabledLogicalElement
EnabledState | uint16 | CIM_EnabledLogicalElement
HealthState | uint16 | CIM_ManagedSystemElement
InstallDate | datetime | CIM_ManagedSystemElement
InstanceID | string | CIM_ManagedElement
MeterType | uint16 | CIM_MeterService
Name | string | CIM_Service
OperatingStatus | uint16 | CIM_ManagedSystemElement
OtherEnabledState | string | CIM_EnabledLogicalElement
OtherMeterType | string | CIM_MeterService
PrimaryOwnerContact | string | CIM_Service
PrimaryOwnerName | string | CIM_Service
PrimaryStatus | uint16 | CIM_ManagedSystemElement
RequestedState | uint16 | CIM_EnabledLogicalElement
Started | boolean | CIM_Service
StartMode | string | CIM_Service
Status | string | CIM_ManagedSystemElement
SystemCreationClassName | string | CIM_Service
SystemName | string | CIM_Service
TimeOfLastStateChange | datetime | CIM_EnabledLogicalElement
TransitioningToState | uint16 | CIM_EnabledLogicalElement
AvailableRequestedStates | uint16[] | CIM_EnabledLogicalElement
OperationalStatus | uint16[] | CIM_ManagedSystemElement
StatusDescriptions | string[] | CIM_ManagedSystemElement

## Class Methods

### Inherited Class Methods

Name | Return Type | Class Origin
--- | --- | ---
RequestStateChange | uint32 | CIM_EnabledLogicalElement
StartService | uint32 | CIM_Service
StopService | uint32 | CIM_Service